/**
* This code was generated by v0 by Vercel.
* @see https://v0.dev/t/sLho4wVl2d9
* Documentation: https://v0.dev/docs#integrating-generated-code-into-your-nextjs-app
*/

/** Add fonts into your Next.js project:

import { Inter } from 'next/font/google'

inter({
  subsets: ['latin'],
  display: 'swap',
})

To read more about using these font, please visit the Next.js documentation:
- App Directory: https://nextjs.org/docs/app/building-your-application/optimizing/fonts
- Pages Directory: https://nextjs.org/docs/pages/building-your-application/optimizing/fonts
**/
import { Dialog, DialogTrigger, DialogContent, DialogHeader, DialogTitle, DialogDescription, DialogFooter } from "@/components/ui/dialog"
import { Button } from "@/components/ui/button"
import { ReactNode, useCallback, useMemo, useState } from "react"
import * as A from '@/types/api'
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome'
import { faCircleCheck, faCircleXmark, faClock, faRotate, faSpinner } from '@fortawesome/free-solid-svg-icons'
import { usePocket } from "@/contexts/PocketContext"
import { API, User } from "@/lib/api"
import { useKeyManagement } from "@/contexts/KeyManagementContext"
import { RoomKey, UserKey } from "@/lib/crypto"

import { createAjv } from '@jsonforms/core';
import { toast } from "react-toastify"
import { RoomsTypeOptions } from "@/types/pocketbase-types"
import { Room } from "@/lib/room"
import { RoomStatus } from "@/types/room"
import { useNavigate } from "react-router-dom"

interface StepState {
	state: "SCHEDULED" | "RUNNING" | "SUCCESS" | "ERROR",
	errorMessage?: string,
}

interface StepData {
	user?: User,
	key?: UserKey,
	room?: Room,
	member_groups: A.Group[],
	member_users: User[],
	recipients: Record<A.UserID, User>,
	state: Record<string, StepState>,
}

type StepDefinition = {
	name: string,
	alwaysReRun?: boolean,
} & ({
	isRunAsync: true,
	run: (stepData: StepData, self: StepDefinition) => Promise<void>,
} | {
	isRunAsync: false,
	run: (stepData: StepData, self: StepDefinition) => void,
})

async function runStep(step: StepDefinition, stepData: StepData): Promise<void> {
	stepData.state[step.name] = {
		state: "RUNNING",
	};
	console.info("Running step '" + step.name + "'")
	const state = stepData.state[step.name];
	if (step.isRunAsync) {
		await step.run(stepData, step).catch((error: unknown) => {
			state.errorMessage = error?.toString();
			state.state = "ERROR";
			console.error("While running step '" + step.name + "' an error occured: " + state.errorMessage);
			throw error;
		});
	} else {
		try {
			step.run(stepData, step);
		} catch (error) {
			state.errorMessage = error?.toString();
			state.state = "ERROR";
			console.error("While running step '" + step.name + "' an error occured: " + state.errorMessage);
			throw error;
		}
	}

	console.info("Step '" + step.name + "' succeeded. Waiting 0.1 seconds anyways.");
	// wait 0.1 seconds to make the user actually see the popup and steps running through.
	// It looks cooler. ;)
	await new Promise((resolve) => { setTimeout(resolve, 100) });

	state.state = "SUCCESS";
}

async function runSteps(steps: StepDefinition[], stepData: StepData, setStepData: React.Dispatch<React.SetStateAction<StepData>>) {
	for (const step of steps) {
		const state = stepData.state[step.name];
		if (state?.state === "RUNNING") {
			throw new Error("Formular wird bereits eingereicht.");
		}
	}
	for (const step of steps) {
		// reschedule steps that are tagged as alwaysReRun
		if (step.alwaysReRun) {
			stepData.state[step.name] = {
				state: "SCHEDULED",
			};
		}
	}
	setStepData({ ...stepData }); // update ui
	for (const step of steps) {
		const state = stepData.state[step.name];
		if (!state || state.state === "SCHEDULED" || state.state === "ERROR") {
			// run this step
			await runStep(step, stepData).finally(() => {
				setStepData({ ...stepData }); // update ui
			});
		}
	}
}

export async function getFormRecipients(API: API, form: A.Form, additionalUsers: User[]) {
	const groups = await API.getGroups(form.recipients);
	const member_groups = groups;
	const member_users = [...additionalUsers];
	const userids: A.UserID[] = [];
	for (const group of member_groups) {
		for (const rawuser of group.members) {
			if (!(rawuser.id in userids)) {
				userids.push(rawuser.id);
			}
		}
	}
	for (const user of member_users) {
		if (!(user.id in userids)) {
			userids.push(user.id);
		}
	}
	const recipients = await API.getUsers(userids);
	return {
		member_groups: member_groups,
		member_users: member_users,
		recipients: recipients,
	};
}

function DisplayStep({
	step,
	stepData,
	retryFn,
}: {
	step: StepDefinition,
	stepData: StepData,
	retryFn: () => void,
}) {
	let icon;
	const state = stepData.state[step.name] ?? {
		state: "SCHEDULED",
	};
	switch (state.state) {
		case "RUNNING":
			icon = <FontAwesomeIcon icon={faSpinner} className="h-5 w-5 animate-spin text-primary" />;
			break;
		case "SUCCESS":
			icon = <FontAwesomeIcon icon={faCircleCheck} className="h-5 w-5 text-green-500" />;
			break;
		case "ERROR":
			icon = <FontAwesomeIcon icon={faCircleXmark} className="h-5 w-5 text-red-500" />;
			break;
		case "SCHEDULED":
		default:
			icon = <FontAwesomeIcon icon={faClock} className="h-5 w-5 text-muted-foreground" />;
			break;
	}

	return (<div className="flex items-center justify-between">
		<div className="flex items-center gap-2">
			{icon}
			<div>
				<span>{step.name}</span>
				{state.state === "ERROR" && state.errorMessage ? <p className="text-red-500">{state.errorMessage}</p> : null}
			</div>
		</div>
		<div className="flex items-center gap-2">
			{/*
			<span className="text-green-500 font-medium">Success</span>
			<span className="text-red-500 font-medium">Error</span>
			<span className="text-primary font-medium">In Progress</span>
			<span className="text-muted-foreground font-medium">Not Started</span>
			*/}
			{state.state === "ERROR" ?
				<Button variant="ghost" size="sm" type="button" onClick={retryFn}>
					<FontAwesomeIcon icon={faRotate} className="h-4 w-4 text-red-500" />
				</Button>
				: null}
		</div>
	</div>)
}

export function FormSubmitButton({
	children,
	disabled,
	form,
	data,
}: {
	children: ReactNode,
	disabled: boolean,
	form: A.Form,
	data: object,
}) {
	const [open, setOpen] = useState(false);
	const { API } = usePocket();
	const { ensureUserHasUnlockedKey } = useKeyManagement();
	const [ajvInstance] = useState(createAjv({
		strict: true,
		strictSchema: true,
		strictNumbers: true,
		strictTypes: true,
		strictTuples: true,
		strictRequired: true,
		allErrors: true,
		verbose: true,
		validateSchema: true,
	}));
	const [stepData, setStepData] = useState({
		state: {},
		member_users: [],
		member_groups: [],
		recipients: {},
	} as StepData);

	const navigate = useNavigate();

	const steps: StepDefinition[] = useMemo(() => [
		{
			name: "Hole Nutzerdaten.",
			alwaysReRun: true,
			isRunAsync: false,
			run: (stepData) => {
				if (API.currentuser) {
					stepData.user = API.currentuser;
				} else {
					throw new Error("Du musst angemeldet sein bevor du ein Formular einreichen kannst.");
				}
				return stepData;
			}
		},
		{
			name: "Hole entsperrten Schlüssel.",
			alwaysReRun: true,
			isRunAsync: true,
			run: async (stepData) => {
				const key = await ensureUserHasUnlockedKey(stepData.user, false);
				if (typeof key === "string" && key === "CANCELED") {
					throw new Error("Du hast das Entsperren/Erstellen vom Schlüssel abgebrochen.");
				}
				stepData.key = key;
			}
		},
		{
			name: "Überprüfe Formulardaten.",
			alwaysReRun: true,
			isRunAsync: false,
			run: () => {
				if (!form.schema) {
					throw new Error("Formular hat kein Datenschema.")
				}
				const validate = ajvInstance.compile(form.schema);
				if (!validate(data)) {
					console.error(validate.errors);
					//throw new Error("Invalide oder unvollständige Formulardaten: " + validate.errors?.toString());
					throw new Error("Invalide oder unvollständige Formulardaten. Insgesamt " + validate.errors?.length + " Fehler.");
				}
			},
		},
		{
			name: "Hole Empfängerdaten.",
			isRunAsync: true,
			run: async (stepData) => {
				stepData.member_users = [stepData.user!];
				const res = await getFormRecipients(API, form, stepData.member_users);
				stepData.member_groups = res.member_groups;
				stepData.recipients = res.recipients;
			}
		},
		{
			name: "Erstelle Raum für Einreichung.",
			isRunAsync: true,
			run: async (stepData) => {
				if (!("subject" in data && typeof data.subject === "string" && data.subject.length >= 3)) {
					throw new Error("Betreff fehlt oder ist zu kurz.");
				}

				// erstelle Raum
				stepData.room = await API.createRoom(
					RoomsTypeOptions.SUBMISSION,
					data.subject,
					form,
					stepData.member_users,
					stepData.member_groups,
				);

				// erstelle roomkey
				stepData.room.setRoomKey(await RoomKey.generate(stepData.room));
			}
		},
		{
			name: "Lade Formulardaten hoch.",
			alwaysReRun: true,
			isRunAsync: true,
			run: async (stepData) => {

				// TODO technisch gesehen gibt es eine race condition zwischen "Überprüfe Formulardaten." und diesem Schritt wo die Daten dann erst verwendet werden.
				// (data.subject wird sogar schon bei "Erstelle Raum für Einreichung." verwendet.)
				// Wir reden hier aber von <0.5s. In dieser Zeit müsste der Nutzer aus dem Dialog rausgehen und einen Wert so ändern, dass er invalide wird.
				// Das ist theoretisch genug Zeit um eine Checkbox zu deaktivieren!
				// Da beim Anzeigen der Einreichung die Daten aber eh wieder validiert werden sollten, sollte das nicht wirklich ein Problem sein.

				await stepData.room!.addEventSubmissionValue(data);
			}
		},
		{
			name: "Lade Empfänger zur Einreichung ein.",
			isRunAsync: true,
			run: async (stepData) => {
				await stepData.room!.reshareKeys()
			}
		},
		{
			name: "Setze Einreichungsstatus.",
			isRunAsync: true,
			run: async (stepData) => {
				await stepData.room!.addEventStatusChange(RoomStatus.OPEN);
			}
		},
		{
			name: "Navigiere in 2s zur Einreichung.",
			isRunAsync: true,
			run: async (stepData) => {
				toast.success("Formular wurde erfolgreich eingereicht.");
				await new Promise((resolve) => { setTimeout(resolve, 2000) });
				navigate("/submission/" + stepData.room!.id);
			}
		},
	], [API, ajvInstance, data, ensureUserHasUnlockedKey, form, navigate]);

	const rerunSteps = useCallback(() => {
		runSteps(steps, stepData, setStepData).then(() => {
			console.info("Alle Schritte wurden erfolgreich durchlaufen.");
		}).catch((error: unknown) => {
			console.error(error);
			toast.error(error?.toString());
		});
	}, [stepData, steps]);


	return (
		<Dialog open={open} onOpenChange={(open) => {
			console.log("onOpenChange", open);
			//// reset step data
			//setStepData({
			//	state: {},
			//	member_users: [],
			//	member_groups: [],
			//	recipients: {},
			//});

			if (open) {
				rerunSteps();
			}

			setOpen(open);
		}}>
			<DialogTrigger asChild disabled={disabled}>
				<Button type="submit" className="w-full" disabled={disabled}>
					{children}
				</Button>
			</DialogTrigger>
			<DialogContent className="sm:max-w-[600px]">
				<DialogHeader>
					<DialogTitle>Formular wird eingereicht</DialogTitle>
					<DialogDescription>
						Bitte lade die Seite nicht neu und schließe diesen Tab nicht während das Formular eingereicht wird.
					</DialogDescription>
				</DialogHeader>
				<div className="space-y-4 py-4">
					<div className="grid gap-2">
						{steps.map((step) => <DisplayStep key={step.name} step={step} stepData={stepData} retryFn={rerunSteps} />)}
					</div>
				</div>
				<DialogFooter>
					{/*<Button variant="outline" onClick={() => { }}>
						Close
					</Button>*/}
				</DialogFooter>
			</DialogContent>
		</Dialog>
	)
}
